local animation = false

local ActivateFunc = function(self)
    if self:GetAlpha() == 1 then return end
    if self.dag:IsPlaying() then self.dag:Stop() end
    self.aag:Play()
    if not animation then
        self.glow2:Play()
    end
end
local DeactivateFunc = function(self)
    if self:GetAlpha() == 0 then return end
    if self.aag:IsPlaying() then self.aag:Stop() end
    self.dag:Play()
end
local SetColorFunc = function(self,r,g,b)
    self.t:SetVertexColor(r,g,b)
    if self.ani then self.ani.tex:SetVertexColor(r,g,b) end
end

function NugComboBar.ConvertTo3(self)
    if NugComboBar.MAX_POINTS == 3 then return end
    NugComboBar.MAX_POINTS = 3
    local p1 = self.p[1]
    local point,parent,to,x,y = p1:GetPoint(1)
    x = x - 24*2
    p1:SetPoint(point,parent,to,x,y)
    local w = 140-48
    self.bgt:SetTexCoord(0, w/256, 0, 1)
    self:SetWidth(w)
    self.bgt:SetTexture("Interface\\Addons\\NugComboBarClassic\\tex\\ncbc_bg3")
    for i=1,5 do
        self.p[i]:Deactivate()
        self.p[i-2] = self.p[i]
    end
    self.p[5] = nil
    self.p[4] = nil
end
function NugComboBar.ConvertTo5(self)
    if NugComboBar.MAX_POINTS == 5 then return end
    NugComboBar.MAX_POINTS = 5
    local p1 = self.p[-1]
    local point,parent,to,x,y = p1:GetPoint(1)
    x = x + 24*2
    p1:SetPoint(point,parent,to,x,y)
    local w = 140
    self.bgt:SetTexCoord(0, w/256, 0, 1)
    self:SetWidth(w)
    self.bgt:SetTexture("Interface\\Addons\\NugComboBarClassic\\tex\\ncbc_bg5")
    for i=5,1,-1 do
        self.p[i] = self.p[i-2]
        self.p[i]:Deactivate()
    end
    self.p[0] = nil
    self.p[-1] = nil
end

NugComboBar.Create = function(self)
    local MAX_POINTS = 5
    self:SetFrameStrata("MEDIUM")
    local w = (MAX_POINTS == 3) and 140-48 or 140
    self:SetWidth(w)
    self:SetHeight(32)

    local bgt = self:CreateTexture(nil,"BACKGROUND")
    bgt:SetTexture("Interface\\Addons\\NugComboBarClassic\\tex\\ncbc_bg"..MAX_POINTS)
    bgt:SetTexCoord(0, w/256, 0, 1)
    bgt:SetAllPoints(self)
    self.bgt = bgt

    local prev = self
    local offsetX = 19
    local offsetY = 2
    local color_offset = 5 - MAX_POINTS
    self.p = {}
    for i=1,MAX_POINTS do
        local size = (MAX_POINTS == i) and 18 or 14
        local tex = [[Interface\Addons\NugComboBarClassic\tex\ncbc_point]]
        local f = CreateFrame("Frame","NugComboBarPoint"..i,self)
        f:SetHeight(size); f:SetWidth(size);
        
        local t = f:CreateTexture(nil,"ARTWORK")
        t:SetTexture(tex)
        t:SetAllPoints(f)
        f.t = t
        
        if i == 1 then
            f:SetPoint("CENTER",prev,"LEFT",offsetX,offsetY)
        else
            f:SetPoint("CENTER",prev,"CENTER",offsetX,offsetY)
        end
        offsetX = (MAX_POINTS == i+1) and 27 or 24
        offsetY = 0  --(MAX_POINTS == i+1) and -3 or 0

        
        
      if animation then
        
        local a = CreateFrame("Frame",nil,f)
        
        local asize = 30
        if i == MAX_POINTS then asize = asize * 1.1 end
        a:SetWidth(asize)
        a:SetHeight(asize*1.5)
        
        a:SetPoint("CENTER",f,"CENTER",1.5,7)
        
        local h = a:CreateTexture(nil,"ARTWORK")
        h:SetTexture("Interface\\AddOns\\NugComboBarClassic\\tex\\fireballanimation1")
        h:SetBlendMode("BLEND")
        h:SetTexCoord(0,0.08333,0,1)
        h:SetAllPoints(a)
        h:SetVertexColor(unpack(NugComboBarDB.colors[i]))
        
        a.tex = h
        a.tex.texcoord = 0 + (0.08333 * i * 2)
        
        local FrameOnUpdate = function (self, time)
            self.OnUpdateCounter = (self.OnUpdateCounter or 0) + time
            if self.OnUpdateCounter < 0.06 then return end
            self.OnUpdateCounter = 0
            self.tex:SetTexCoord(self.tex.texcoord, self.tex.texcoord + 0.08333,0,1)
            self.tex.texcoord = self.tex.texcoord + 0.08333
            if self.tex.texcoord > 0.99 then self.tex.texcoord = 0; end
        end
        a:SetScript("OnUpdate",FrameOnUpdate)
        a:SetAlpha(1)
        
        f.ani = a
        
      else
        
        local f2 = CreateFrame("Frame",nil,f)
        f2:SetHeight(size+3); f2:SetWidth(size+3);
        local g2 = f2:CreateTexture(nil,"OVERLAY")
        g2:SetAllPoints(f2)
        g2:SetTexture[[Interface\Addons\NugComboBarClassic\tex\ncbc_point_shine]]
        f2:SetPoint("CENTER",f,"CENTER",0,2)
        
        f2:SetAlpha(0)
        
        local g2aag = f2:CreateAnimationGroup()
        local g2a = g2aag:CreateAnimation("Alpha")
        g2a:SetStartDelay(0.4)
        g2a:SetChange(1)
        g2a:SetDuration(0.3)
        g2a:SetOrder(1)
        local g2d = g2aag:CreateAnimation("Alpha")
        g2d:SetChange(-1)
        g2d:SetDuration(0.4)
        g2d:SetOrder(2)
        f.glow2 = g2aag
        --Required for 4.2
        g2aag:SetScript("OnFinished",function(self)
            self:GetParent():SetAlpha(0)
        end)
        
      end
        
        
        
        
        
        
        f.SetColor = SetColorFunc
        f:SetColor(unpack(NugComboBarDB.colors[i+color_offset]))
        
        f:SetAlpha(0)
        
        prev = f
        
        local aag = f:CreateAnimationGroup()
        f.aag = aag
        local a1 = aag:CreateAnimation("Alpha")
        a1:SetChange(1)
        a1:SetDuration(0.4)
        a1:SetOrder(1)
        aag:SetScript("OnFinished",function(self)
            self:GetParent():SetAlpha(1)
        end)
        
        local dag = f:CreateAnimationGroup()
        f.dag = dag
        local d1 = dag:CreateAnimation("Alpha")
        d1:SetChange(-1)
        d1:SetDuration(0.5)
        d1:SetOrder(1)
        dag:SetScript("OnFinished",function(self)
            self:GetParent():SetAlpha(0)
        end)
        
        
        f.Activate = ActivateFunc
        f.Deactivate = DeactivateFunc
        self.p[i] = f
    end
    
    return self
end